# LFEV 2015 CAN Communications Microprocessor Hardware #
This directory contains the CAN communications board (JGB) designed for the spring 2015 semester.


## Overview ##
This circuit board is the primary interface between SCADA and all other systems. It is used to interface low level devices such as relays, ADCs, and other inputs/outputs to the SCADA computer via a CAN bus. This board was designed for prototyping purposes, and ensures consitant message format is used on the CAN bus. Any device which communicates via the CAN bus should inteface through this board.

The microcontroller present on this board, and the software which runs on it should eventually be integrated into each node which must communicate via the CAN bus.


## System Capabilities ##


## Target Device ##
This software is written for the **Atmel ATMEGA 16M1 Automotive AVR**  
  
This device was selected for its price, software availability, documentation and onboard CAN bus support.

1. [ATMega16M1 Overview](http://www.atmel.com/devices/atmega16m1.aspx)
2. [ATMega16M1 Datasheet](http://www.atmel.com/images/doc8209.pdf)

### Features ###

* Atmel® AVR® 8-bit microcontroller
* Up to 1 MIPS throughput per MHz
* 16KBytes flash of in-system programmable program memory
* 512B of in-system programmable EEPROM
* 1KBytes internal SRAM
* On-chip debug interface (debugWIRE)
* CAN 2.0A/B with six message objects - ISO 16845 certified
* Variable PWM duty cycle and frequency
* Synchronous update of all PWM registers
* Peripheral features
* One 8-bit general purpose timer/counter
* One 16-bit general purpose timer/counter
* One master/slave SPI serial interface
* 10-bit ADC
	* 11 single ended channels
	* Three differential ADC channel pairs (5×, 10×, 20×, 40×)
* 10-bit DAC for variable voltage reference (comparators, ADC)
* Programmable watchdog timer with separate on-chip oscillator
* On-chip temperature sensor

### Operating Specifications ###

- Operating voltage: 2.7V - 5.5V
- Extended operating temperature:
- -40°C to +85°C
- Core speed grade:
- 0 - 8MHz @ 2.7 - 4.5V
- 0 - 16MHz @ 4.5 - 5.5V

## EDA Software Suite ##

### EDA Software Suite: ###
KiCad 'old-stable' was used to design this PCB. The technical revision was KiCad (2013-may-18)-stable, run under Gentoo Linux. The source code can be found at [kicad-20130518.ebuild](https://packages.gentoo.org/package/sci-electronics/kicad)

### Component Libraries: ###
The following KiCad libraries were used in the creation of this PCB.

1. [Walter KiCad Libraries](http://smisioto.no-ip.org/elettronica/kicad/kicad-en.htm)

### Gerber Files ###
The latest GERBER files submitted for fabrication can be found in the repository under 'can-embd/hardware/gerber/' or in the BitBucket 'Downloads' page.

## Bill of Materials ##
All parts for this board were ordered through digikey, and have a DigiKey parts number (P/N) and URL associated with them in the KiCad schematic.  
  
These associations can also be viewed in the Bill of Materials (hardware/BOM.csv).  
A BOM (DigiKey ID: 2503580) has been created, which is summarized in the 'DigiKey BOM' file below. 

1. [DigiKey BOM](DigiKey_BOM.csv) This BOM contains the required DigiKey parts to build a single board.
2. [KiCad BOM](BOM.csv) This file contains a list of all components generated by KiCad.
